# Calico/VPP technical documentation

This folder contains Calico/VPP technical documentation. This is this repository's counterpart of the documentation available at [https://docs.tigera.io](https://docs.tigera.io/calico/latest/reference/vpp/technical-details)

It contains developer oriented documentation, details of VPP specific features :

- [Interface configuration](config.md)
- [Developer's getting started](developper_guide.md)
- [Multinet feature documentation](multinet.md)
- [Existing Calico cluster migration](migrate_to_calicovpp.md)
- [External resources](events.md) like events and presentations
- [Guide to upgrade calico](upgrading.md)
- [A networking model deep dive](networkmodel.md)

Additionally this repository contains :

- [A series of examples yamls](../test/yaml)
- [A Simple VCL client and server example](../test/yaml/simple-vcl)
- [A trex pod example](../test/yaml/trex)
- [A vpp client pod example](../test/yaml/mvpp)
- [An envoy pod example with optional VCL support](../test/yaml/envoy)
